import Ember from 'ember';
import moment from 'moment';
import layout from '../templates/components/powered-datepicker';

export default Ember.Component.extend({

  layout,

  format: 'L',

  classNames: ['powered-datepicker'],

  inputId: Ember.computed(function() {
    return `input-${Ember.guidFor(this)}`;
  }),

  textInputValue: Ember.computed('value', 'format', {
    get(key) {
      const value = this.get('value');
      if (Ember.isEmpty(value)) {
        return '';
      }
      const momentized = moment(value);
      return momentized.isValid() ? momentized.format(this.get('format')) : '';
    },
    set(key, value) {
      if (Ember.isEmpty(value)) {
        this.set('value', null);
        return value;
      }
      const momentized = moment(value, this.get('format'));
      if (momentized.isValid()) {
        this.set('value', momentized);
      }
      return value;
    }
  }),

  didReceiveAttrs: function() {
    if (!this.get('minDate') && this.get('minDateToday')) {
      this.set('minDate', moment());
    }
  },

  disabledObserver: Ember.observer('disabled', function() {
    if (this.get('disabled')) {
      this.set('calendarShown', false);
    }
  })

});
